#ifndef CONF_H_GUARD
#define CONF_H_GUARD

#include <nspr.h>
#include "config.h"
#include "lib/iniparser.h"

typedef struct
{
    int exporters;              /* # of exporters (routers) we collect from */
    void* whitelist;            /* whitelist of exporter IP addresses */
    int threads;                /* # of datagram processing threads */
    int port;                   /* UDP listen port */
    PRBool normalizeFlowTimes;  /* whether to normalize flow times */
    int tcpSessAggHz;           /* tcp session aggregations per sec */
    int udpSessAggHz;           /* udp session aggregations per sec */
    int otherSessAggHz;         /* other session aggregations per sec */
    int srcTraffAggHz;          /* source traffic aggregations per sec */
    int dstTraffAggHz;          /* destination traffic aggregations per sec */
    PRNetAddr netAddr;          /* for UDP bind */
    char listen[64];            /* UDP listen address */
    char dbConnect[128];        /* database connect string */
    char fn[MAX_CONF_STRLEN+1]; /* conf file name */
}
conf_t;

#include "globals.h"

/* load the specified conf file */
PR_EXTERN(PRStatus) load_conf(conf_t*);

#endif  /* CONF_H_GUARD */
