/* Processed by ecpg (4.4.1) */
/* These include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "database.pgc"
/* emacs hints: -*- C -*- */
#include <nspr.h>
#include "database.h"
#include "globals.h"

/* exec sql whenever sql_warning  goto  db_warning ; */
#line 6 "database.pgc"

/* exec sql whenever sqlerror  goto  db_error ; */
#line 7 "database.pgc"



static void db_perror()
{
    struct sqlca_t * _sqlca;

    _sqlca = ECPGget_sqlca();

    if (NULL == _sqlca)
    {
        PR_LogPrint("db_perror: ECPGget_sqlca returned NULL");
        return;
    }

    if (0 <= _sqlca->sqlcode)
    {
        PR_LogPrint("db_perror: no error");
        return;
    }

    PR_LogPrint(_sqlca->sqlerrm.sqlerrmc);
}


PR_IMPLEMENT(PRStatus) db_connect(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
    
#line 35 "database.pgc"
 const char * dbConnect   = globals . conf . dbConnect ;
 
#line 36 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
/* exec sql end declare section */
#line 37 "database.pgc"


    dbData->beginPrepared = PR_FALSE;
    dbData->stmtPrepared = PR_FALSE;
    dbData->commitPrepared = PR_FALSE;
    dbData->rollbackPrepared = PR_FALSE;

    { ECPGconnect(__LINE__, 0, dbConnect , NULL, NULL , id, 0); 
#line 44 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 44 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 44 "database.pgc"


    LOG_DEBUG(globals.dlogger, PR_LOG_DEBUG, ("db_connect: connected to %s as %s", dbConnect, id));

    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_connect warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_connect failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRStatus) db_disconnect(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
    
#line 71 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
/* exec sql end declare section */
#line 72 "database.pgc"


    { ECPGdisconnect(__LINE__, id);
#line 74 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 74 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 74 "database.pgc"


    dbData->beginPrepared = PR_FALSE;
    dbData->stmtPrepared = PR_FALSE;
    dbData->commitPrepared = PR_FALSE;
    dbData->rollbackPrepared = PR_FALSE;

    LOG_DEBUG(globals.dlogger, PR_LOG_DEBUG, ("db_disconnect: disconnected %s", id));

    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_disconnect warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_disconnect failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRStatus) db_begin(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
    
#line 106 "database.pgc"
 const char * stmt   = "BEGIN READ WRITE;" ;
 
#line 107 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
/* exec sql end declare section */
#line 108 "database.pgc"


    if (PR_FALSE == dbData->beginPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_begin", stmt);
#line 112 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 112 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 112 "database.pgc"

        dbData->beginPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_begin", ECPGt_EOIT, ECPGt_EORT);
#line 116 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 116 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 116 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_begin warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_begin failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRStatus) db_commit(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
    
#line 141 "database.pgc"
 const char * stmt   = "COMMIT;" ;
 
#line 142 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
/* exec sql end declare section */
#line 143 "database.pgc"


    if (PR_FALSE == dbData->commitPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_commit", stmt);
#line 147 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 147 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 147 "database.pgc"

        dbData->commitPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_commit", ECPGt_EOIT, ECPGt_EORT);
#line 151 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 151 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 151 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_commit warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_commit failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRStatus) db_rollback(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
    
#line 176 "database.pgc"
 const char * stmt   = "ROLLBACK;" ;
 
#line 177 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
/* exec sql end declare section */
#line 178 "database.pgc"


    if (PR_FALSE == dbData->rollbackPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_rollback", stmt);
#line 182 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 182 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 182 "database.pgc"

        dbData->rollbackPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_rollback", ECPGt_EOIT, ECPGt_EORT);
#line 186 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 186 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 186 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_rollback warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_rollback failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRInt64) db_get_top_flow_id(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 211 "database.pgc"
 const char * stmt   = "SELECT last_value FROM flow_id_seq;" ;
 
#line 212 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 213 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 214 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_get_top_flow", stmt);
#line 218 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 218 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 218 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_get_top_flow", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 222 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 222 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 222 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_get_top_flow_id warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_get_top_flow_id failed");

    db_perror();

    return LL_Zero();
}


PR_IMPLEMENT(PRStatus) db_insert(db_data_t* dbData, PRTime bootTime, const char* routerIP, nfv5_record_t* rec)
{
    PRTime _first, _last;
    PRExplodedTime exploded_first, exploded_last;
    PRNetAddr n;
    static char* pgTimeFmt="%4d-%02d-%02d %02d:%02d:%02d.%06d GMT";
    static char* zip = "0.0.0.0";

    /* exec sql begin declare section */
       
        
        
        
        
        
        
        
      
      
      
         
          
         
         
      
      
         
         
          
          
          
         
         
          
          
    
#line 253 "database.pgc"
 const char * stmt   = "INSERT INTO flow(" "router, src_addr, dst_addr, next_hop, start_time, end_time," " tcp_flags, prot, tos, input_if, output_if," " src_as, dst_as, src_port, dst_port, src_mask, dst_mask, pkts, bytes)" " VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);" ;
 
#line 259 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 260 "database.pgc"
 const char * router   = routerIP ;
 
#line 261 "database.pgc"
 const char  src_addr [ 64 ]    ;
 
#line 262 "database.pgc"
 const char  dst_addr [ 64 ]    ;
 
#line 263 "database.pgc"
 const char  next_hop [ 64 ]    ;
 
#line 264 "database.pgc"
 const unsigned int  input_if   = rec -> input ;
 
#line 265 "database.pgc"
 const unsigned int  output_if   = rec -> output ;
 
#line 266 "database.pgc"
 const unsigned int  pkts   = rec -> dPkts ;
 
#line 267 "database.pgc"
 const unsigned int  bytes   = rec -> dOctets ;
 
#line 268 "database.pgc"
 const char  start_time [ 32 ]    ;
 
#line 269 "database.pgc"
 const char  end_time [ 32 ]    ;
 
#line 270 "database.pgc"
 const unsigned int  src_port   = rec -> srcport ;
 
#line 271 "database.pgc"
 const unsigned int  dst_port   = rec -> dstport ;
 
#line 272 "database.pgc"
 const unsigned int  tcp_flags   = rec -> tcp_flags ;
 
#line 273 "database.pgc"
 const unsigned int  prot   = rec -> prot ;
 
#line 274 "database.pgc"
 const unsigned int  tos   = rec -> tos ;
 
#line 275 "database.pgc"
 const unsigned int  src_as   = rec -> src_as ;
 
#line 276 "database.pgc"
 const unsigned int  dst_as   = rec -> dst_as ;
 
#line 277 "database.pgc"
 const unsigned int  src_mask   = rec -> src_mask ;
 
#line 278 "database.pgc"
 const unsigned int  dst_mask   = rec -> dst_mask ;
/* exec sql end declare section */
#line 279 "database.pgc"


    LL_UI2L(_first, rec->first);
    LL_MUL(_first, _first, PR_USEC_PER_MSEC);
    LL_ADD(_first, _first, bootTime);

    LL_UI2L(_last, rec->last);
    LL_MUL(_last, _last, PR_USEC_PER_MSEC);
    LL_ADD(_last, _last, bootTime);

    PR_ExplodeTime(_first, PR_GMTParameters, &exploded_first);
    PR_snprintf((char*)start_time, sizeof(start_time), pgTimeFmt,
                exploded_first.tm_year, exploded_first.tm_month+1, exploded_first.tm_mday,
                exploded_first.tm_hour, exploded_first.tm_min, exploded_first.tm_sec, exploded_first.tm_usec);

    PR_ExplodeTime(_last, PR_GMTParameters, &exploded_last);
    PR_snprintf((char*)end_time, sizeof(end_time), pgTimeFmt,
                exploded_last.tm_year, exploded_last.tm_month+1, exploded_last.tm_mday,
                exploded_last.tm_hour, exploded_last.tm_min, exploded_last.tm_sec, exploded_last.tm_usec);

    PR_InitializeNetAddr(PR_IpAddrAny, 0, &n);

    n.inet.ip = rec->srcaddr;
    if (PR_FAILURE == PR_NetAddrToString(&n, (char*)src_addr, sizeof(src_addr)))
    {
        PL_strcpy(src_addr, zip);
    }

    n.inet.ip = rec->dstaddr;
    if (PR_FAILURE == PR_NetAddrToString(&n, (char*)dst_addr, sizeof(dst_addr)))
    {
        PL_strcpy(dst_addr, zip);
    }

    n.inet.ip = rec->nexthop;
    if (PR_FAILURE == PR_NetAddrToString(&n, (char*)next_hop, sizeof(next_hop)))
    {
        PL_strcpy(next_hop, zip);
    }

    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_insert", stmt);
#line 321 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 321 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 321 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_insert", 
	ECPGt_char,&(router),(long)0,(long)1,(1)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(src_addr),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(dst_addr),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(next_hop),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(start_time),(long)32,(long)1,(32)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(end_time),(long)32,(long)1,(32)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(tcp_flags),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(prot),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(tos),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(input_if),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(output_if),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(src_as),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(dst_as),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(src_port),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(dst_port),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(src_mask),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(dst_mask),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(pkts),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(bytes),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 328 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 328 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 328 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_insert warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_insert failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRStatus) db_age_tcp_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
        
    
#line 353 "database.pgc"
 const char * stmt   = "SELECT age_tcp_session();" ;
 
#line 354 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 355 "database.pgc"
 long long  flowId   = 0 ;
/* exec sql end declare section */
#line 356 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_age_tcp_session", stmt);
#line 360 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 360 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 360 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_age_tcp_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 364 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 364 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 364 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_age_tcp_session warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_age_tcp_session failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRInt64) db_aggregate_tcp_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 389 "database.pgc"
 const char * stmt   = "SELECT aggregate_tcp_session();" ;
 
#line 390 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 391 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 392 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "aggregate_tcp_session", stmt);
#line 396 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 396 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 396 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "aggregate_tcp_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 400 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 400 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 400 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_aggregate_tcp_session warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_aggregate_tcp_session failed");

    db_perror();

    return LL_Zero();
}


PR_IMPLEMENT(PRStatus) db_age_udp_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
        
    
#line 425 "database.pgc"
 const char * stmt   = "SELECT age_udp_session();" ;
 
#line 426 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 427 "database.pgc"
 long long  flowId   = 0 ;
/* exec sql end declare section */
#line 428 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_age_udp_session", stmt);
#line 432 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 432 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 432 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_age_udp_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 436 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 436 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 436 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_age_udp_session warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_age_udp_session failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRInt64) db_aggregate_udp_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 461 "database.pgc"
 const char * stmt   = "SELECT aggregate_udp_session();" ;
 
#line 462 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 463 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 464 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "aggregate_udp_session", stmt);
#line 468 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 468 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 468 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "aggregate_udp_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 472 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 472 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 472 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_aggregate_udp_session warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_aggregate_udp_session failed");

    db_perror();

    return LL_Zero();
}

PR_IMPLEMENT(PRStatus) db_age_other_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
        
    
#line 496 "database.pgc"
 const char * stmt   = "SELECT age_other_session();" ;
 
#line 497 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 498 "database.pgc"
 long long  flowId   = 0 ;
/* exec sql end declare section */
#line 499 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "db_age_other_session", stmt);
#line 503 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 503 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 503 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "db_age_other_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 507 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 507 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 507 "database.pgc"


    return PR_SUCCESS;

db_warning:

    PR_LogPrint("db_age_other_session warning");

    db_perror();

    return PR_FAILURE;

db_error:

    PR_LogPrint("db_age_other_session failed");

    db_perror();

    return PR_FAILURE;
}


PR_IMPLEMENT(PRInt64) db_aggregate_other_session(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 532 "database.pgc"
 const char * stmt   = "SELECT aggregate_other_session();" ;
 
#line 533 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 534 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 535 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "aggregate_other_session", stmt);
#line 539 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 539 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 539 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "aggregate_other_session", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 543 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 543 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 543 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_aggregate_other_session warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_aggregate_other_session failed");

    db_perror();

    return LL_Zero();
}


PR_IMPLEMENT(PRInt64) db_aggregate_src_traffic(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 568 "database.pgc"
 const char * stmt   = "SELECT aggregate_src_traffic();" ;
 
#line 569 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 570 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 571 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "aggregate_src_traffic", stmt);
#line 575 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 575 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 575 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "aggregate_src_traffic", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 579 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 579 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 579 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_aggregate_src_traffic warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_aggregate_src_traffic failed");

    db_perror();

    return LL_Zero();
}


PR_IMPLEMENT(PRInt64) db_aggregate_dst_traffic(db_data_t* dbData)
{
    /* exec sql begin declare section */
        
        
      
    
#line 604 "database.pgc"
 const char * stmt   = "SELECT aggregate_dst_traffic();" ;
 
#line 605 "database.pgc"
 const char * id   = dbData -> dbConnectId ;
 
#line 606 "database.pgc"
 long long  flowId    ;
/* exec sql end declare section */
#line 607 "database.pgc"


    if (PR_FALSE == dbData->stmtPrepared)
    {
        { ECPGprepare(__LINE__, NULL, 0, "aggregate_dst_traffic", stmt);
#line 611 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 611 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 611 "database.pgc"

        dbData->stmtPrepared = PR_TRUE;
    }

    { ECPGdo(__LINE__, 0, 1, id, 0, 1, "aggregate_dst_traffic", ECPGt_EOIT, 
	ECPGt_long_long,&(flowId),(long)1,(long)1,sizeof(long long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 615 "database.pgc"

if (sqlca.sqlwarn[0] == 'W') goto db_warning;
#line 615 "database.pgc"

if (sqlca.sqlcode < 0) goto db_error;}
#line 615 "database.pgc"


    return flowId;

db_warning:

    PR_LogPrint("db_aggregate_dst_traffic warning");

    db_perror();

    return LL_Zero();

db_error:

    PR_LogPrint("db_aggregate_dst_traffic failed");

    db_perror();

    return LL_Zero();
}
