#ifndef DATABASE_H_GUARD
#define DATABASE_H_GUARD

/* db connect id buff size must be >= 21 chars long */
#define DBCONNECTIDMAXSZ 32
typedef struct
{
    char dbConnectId[DBCONNECTIDMAXSZ]; /* db connection id buf */
    PRBool beginPrepared;
    PRBool stmtPrepared;
    PRBool commitPrepared;
    PRBool rollbackPrepared;
}
db_data_t;

#include "netflow.h"

PR_EXTERN(PRStatus) db_connect(db_data_t*);

PR_EXTERN(PRStatus) db_disconnect(db_data_t*);

PR_EXTERN(PRStatus) db_begin(db_data_t*);

PR_EXTERN(PRStatus) db_commit(db_data_t*);

PR_EXTERN(PRStatus) db_rollback(db_data_t*);

PR_EXTERN(PRInt64) db_get_top_flow_id(db_data_t*);

PR_EXTERN(PRStatus) db_insert(db_data_t*, PRTime, const char*, nfv5_record_t*);

PR_EXTERN(PRStatus) db_age_tcp_session(db_data_t*);

PR_EXTERN(PRInt64) db_aggregate_tcp_session(db_data_t*);

PR_EXTERN(PRStatus) db_age_udp_session(db_data_t*);

PR_EXTERN(PRInt64) db_aggregate_udp_session(db_data_t*);

PR_EXTERN(PRStatus) db_age_other_session(db_data_t*);

PR_EXTERN(PRInt64) db_aggregate_other_session(db_data_t*);

PR_EXTERN(PRInt64) db_aggregate_src_traffic(db_data_t*);

PR_EXTERN(PRInt64) db_aggregate_dst_traffic(db_data_t*);

#endif  /* DATABASE_H_GUARD */
