#ifndef GLOBALS_H_GUARD
#define GLOBALS_H_GUARD

#include <nspr.h>
#include "conf.h"
#include "threads.h"

/* global variables structure */
typedef struct
{
    thread_status_t runStatus;
    char* name;                 /* this executable name sans directory */
    PRLogModuleInfo* logger;    /* normal log */
    PRFileDesc* udpSocket;      /* for UDP bind */
    conf_t conf;                /* conf file items */
#ifdef DEBUG
    PRLogModuleInfo* dlogger;   /* debug log */
    PRInt32 dgCount;            /* number of datagrams received */
#endif
}
globals_t;

PR_EXTERN(globals_t) globals;

#endif  /* GLOBALS_H_GUARD */
