#include "pfcapd.h"

PR_IMPLEMENT(void) prerror(const char* s)
{
    char* text;
    PRInt32 text_len = PR_GetErrorTextLength();

    PR_LogPrint("%s: error %d", s, PR_GetError());
    if (0 != text_len)
    {
        text = PR_Calloc(text_len, 1);
        if (NULL == text)
        {
            PR_LogPrint("pferror(): PR_Calloc(): error %d", PR_GetError());
            return;
        }
        else if (PR_GetErrorText(text))
        {
            PR_LogPrint(text);
        }
        PR_FREEIF(text);
    }
}

PR_IMPLEMENT(void) prerror_abort(const char* s)
{
    prerror(s);
    PR_LogFlush();
    PR_Abort();
}
