#ifndef THREADS_H_GUARD
#define THREADS_H_GUARD

#include <nspr.h>
#include "database.h"

typedef enum {
    ts_normal = 0,              /* normal running status */
    ts_restart = 1,             /* restart underway */
    ts_stop = 2                 /* shutting down */
}
thread_status_t;

typedef struct thread_vector
{
    void (*func)(void*);        /* thread function */
    const char* name;           /* thread function name */
    PRThread* thread;           /* thread */
    volatile thread_status_t status;
    db_data_t dbData;
}
thread_vector_t;

#include "pfcapd.h"

/* start all threads */
PR_EXTERN(PRStatus) start_threads();

/* stop all threads and optionally restart them */
PR_EXTERN(PRStatus) stop_threads(thread_status_t);

/* current time, updated once per sec by aggregate_monitor_thread */
PR_EXTERN(volatile PRTime) timeNow;

#endif  /* THREADS_H_GUARD */
