#!/usr/bin/python

import psycopg2
import logging
import sqlalchemy 
from turbogears import config
from string import Template
from datetime import timedelta, datetime

dbString = config.get('psyche.dburi')
log = logging.basicConfig(filename='debug.log', level=logging.DEBUG)
#log = logging.getLogger("psychefe.storedProcedures")

class CursorControl:
	def __init__(self, args, query):
		self.conn = psycopg2.connect(dbString)
		dispatcher = CursorSPDispatcher(conn=self.conn)

		# begin sqlalchemy test code
		#engine = sqlalchemy.create_engine('postgres://psyche:""@localhost/psyche', echo=True)
		#query = sqlalchemy.text("""SELECT * FROM flow limit 10""")
		#res = engine.execute(query).fetchall()
		#for r in res:
		    #logging.debug("result: " + str(r['src_addr']))
		# end sqlalchemy test code

		#TODO: change later
		if query == 'get_sessions':
			self.cur = dispatcher.do_get_sessions(args)
		elif query == 'get_raw_flows':
			self.cur = dispatcher.do_get_raw_flows(args)
		elif query == 'get_traffic':
			self.cur = dispatcher.do_get_traffic(args)
		elif query == 'get_internal_servers':
			self.cur = dispatcher.do_get_internal_servers(args)
		elif query == 'get_internal_nets':
			self.cur = dispatcher.do_get_internal_nets(args)
		elif query == 'get_session_counts':
			self.cur = dispatcher.do_get_session_counts(args)

		try:
			self.refCursor = self.cur.fetchall()
			#self.conn.commit()
		except:
			self.cur = None
			self.conn.commit()
			return None

		if self.refCursor[0][1] == None:
			self.endSess()
			return None

	def count(self):
		if self.cur and not self.cur.closed:
			return self.refCursor[0][0]
		else:
			return None

	def getResults(self, start=0, count=1):
		if self.cur and self.cur.closed:
			return 'Cursor already closed'

		spString = 'move absolute ' + str(start) + ' from "' + self.refCursor[0][1] + '"'
		try:
			self.cur.execute(spString)
		except:
			self.conn.rollback()
			return None

		if (start + count) > self.count():
			count = int(self.count()) - start

		spString = 'fetch forward ' + str(count) + ' from "' + self.refCursor[0][1] + '"'
		try:
			self.cur.execute(spString)
		except:
			self.conn.rollback()
			return None

		#self.conn.commit()

		return self.cur.fetchall() #results

	def endSess(self):
		self.conn.commit()
		self.cur.close()

class CursorSPDispatcher:
	def __init__(self, conn=None):
	#dbString = Template("dbname='$dbname' user='$user' password='$password' host='$host'").substitute(dbDict)
		if conn == None:
			self.conn = psycopg2.connect(dbString)
		else:
			self.conn = conn

	def do_get_traffic(self, args):
		spParamsList = []
		spParamsList.append('network')
		spParamsList.append('router')
		spParamsList.append('direction')
		spParamsList.append('inc_prot_ranges')
		spParamsList.append('inc_prots')
		spParamsList.append('exc_prot_ranges')
		spParamsList.append('exc_prots')
		spParamsList.append('inc_port_ranges')
		spParamsList.append('inc_ports')
		spParamsList.append('exc_port_ranges')
		spParamsList.append('exc_ports')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('column')
		spParamsList.append('order')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				elif key in spParamsList:
					spParams[key] = str(args[key])

		spString = 'select * from get_traffic('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)
		logging.error(sql)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_traffic")
			self.conn.rollback()
			return None
		
		return cur

	def do_get_sessions(self, args):
		spParamsList = []
		spParamsList.append('network')
		spParamsList.append('router')
		spParamsList.append('inc_prot_ranges')
		spParamsList.append('inc_prots')
		spParamsList.append('exc_prot_ranges')
		spParamsList.append('exc_prots')
		spParamsList.append('inc_port_ranges')
		spParamsList.append('inc_ports')
		spParamsList.append('exc_port_ranges')
		spParamsList.append('exc_ports')
		spParamsList.append('min_ratio')
		spParamsList.append('max_ratio')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('column')
		spParamsList.append('order')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				elif key in spParamsList:
					spParams[key] = str(args[key])

		spString = 'select * from get_sessions('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure bw_ratio")
			self.conn.rollback()
			return None
		
		return cur

	def do_get_raw_flows(self, args):
		spParamsList = []
		spParamsList.append('src_network')
		spParamsList.append('dst_network')
		spParamsList.append('router')
		spParamsList.append('inc_prot_ranges')
		spParamsList.append('inc_prots')
		spParamsList.append('exc_prot_ranges')
		spParamsList.append('exc_prots')
		spParamsList.append('inc_port_ranges')
		spParamsList.append('inc_ports')
		spParamsList.append('exc_port_ranges')
		spParamsList.append('exc_ports')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('column')
		spParamsList.append('order')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				else:
					spParams[key] = str(args[key])

		spString = 'select * from get_flows('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_flows")
			self.conn.rollback()
			return None
		
		return cur

	def do_get_internal_servers(self, args):
		spParamsList = []
		spParamsList.append('internal_net')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('column')
		spParamsList.append('order')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'internal_net' or key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				else:
					spParams[key] = str(args[key])

		spString = 'select * from get_internal_servers('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_internal_servers")
			self.conn.rollback()
			return None
		
		return cur

	def do_get_internal_nets(self, args):
		spString = 'select * from get_internal_nets(' + args['order'] + ')'

		sql = Template(spString)
		sql = sql.substitute()

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_internal_nets")
			self.conn.rollback()
			return None
		
		return cur

	def do_get_session_counts(self, args):
		spParamsList = []
		spParamsList.append('internal_net')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('column')
		spParamsList.append('order')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'internal_net' or key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				else:
					spParams[key] = str(args[key])

		spString = 'select * from get_session_counts('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_session_counts")
			self.conn.rollback()
			return None
		
		return cur

class SPDispatcher:
	def __init__(self,dbString):
	#dbString = Template("dbname='$dbname' user='$user' password='$password' host='$host'").substitute(dbDict)
		self.conn = psycopg2.connect(dbString)

	def do_bw_ratio(self,args):

		# order is important,
		# it will be the order which they
		# they are specified in the stored procedure
		spParamsList = []
		spParamsList.append('network')
		spParamsList.append('router')
		spParamsList.append('inc_prot_ranges')
		spParamsList.append('inc_prots')
		spParamsList.append('exc_prot_ranges')
		spParamsList.append('exc_prots')
		spParamsList.append('inc_port_ranges')
		spParamsList.append('inc_ports')
		spParamsList.append('exc_port_ranges')
		spParamsList.append('exc_ports')
		spParamsList.append('num_buckets')
		spParamsList.append('min_ratio')
		spParamsList.append('max_ratio')
		spParamsList.append('start_time')
		spParamsList.append('end_time')

		spParams = dict([(param, 'null') for param in spParamsList])

		for key in args.keys():
			if (args[key] != None):
				if key == 'end_time' or key == 'start_time':
					spParams[key] = "'" +  str(args[key]) + "'"
				else:
					spParams[key] = str(args[key])

		spString = 'select * from bw_ratio('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure bw_ratio")
			self.conn.rollback()
			return None

		results = cur.fetchall()

		if results[0][1] == None:
			self.conn.commit()
			return None

		try:
			cur.execute("fetch all from \"" + results[0][1] + "\"") 
		except:
			logging.error("Error fetching data from the result cursor in the stored procedure bw_ratio")
			self.conn.rollback()
			return None
		results = cur.fetchall()
		self.conn.commit()

		dataseries = []
		dataseries = [list(result) for result in results]
		return dataseries

	def do_get_top_talkers(self,args):

		# order is important,
		# it will be the order which they
		# they are specified in the stored procedure
		spParamsList = []
		spParamsList.append('network')
		spParamsList.append('router')
		spParamsList.append('direction')
		spParamsList.append('inc_prot_ranges')
		spParamsList.append('inc_prots')
		spParamsList.append('exc_prot_ranges')
		spParamsList.append('exc_prots')
		spParamsList.append('inc_port_ranges')
		spParamsList.append('inc_ports')
		spParamsList.append('exc_port_ranges')
		spParamsList.append('exc_ports')
		spParamsList.append('num_talkers')
		spParamsList.append('talker_type')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('time_interval')

		spParams = dict([(param, 'null') for param in spParamsList])

		# initialize all parameters to null
		#for param in spParamsList:
		#	spParams[param] = 'null'

		# replace parameters specified by args
		for key in args.keys():
			if (args[key] != None):
				if key == 'end_time' or key == 'start_time' or key == 'time_interval':
					spParams[key] = "'" +  str(args[key]) + "'"
				else:
					spParams[key] = str(args[key])

		spString = 'begin; select * from get_top_talkers('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure get_top_talkers")
			self.conn.rollback()
			return None

		results = cur.fetchall()

		if results[0][1] == None:
			self.conn.commit()
			return None

		try:
			cur.execute("fetch all from \"" + results[0][1] + "\"") 
		except:
			logging.error("Error fetching data from the results cursor in the stored procedure get_top_talkers.")
			self.conn.rollback()
			return None

		results = cur.fetchall()
		#self.conn.commit()

		##############################################
		## prepare results for the graph to display
		##############################################

		INTERVAL = 0
		TALKER = 1
		BW = 2

		start_time = args['start_time']
		#logging.debug(start_time)

		# figure out what the first interval is supposed to be 
		year = start_time.year
		month = start_time.month
		day = start_time.day
		hour = start_time.hour
		minute = ((start_time.minute / 5) * 5 )
		tzinfo = start_time.tzinfo

		if args['time_interval'] == '4 hours':
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		elif args['time_interval'] == '1 day':
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(minutes = 30)
		else: # 2 days
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(hours = 1)

		end_time = args['end_time']

		# figure out what the first interval is supposed to be 
		year = end_time.year
		month = end_time.month
		day = end_time.day
		hour = end_time.hour
		minute = ((end_time.minute / 5) * 5 )
		tzinfo = end_time.tzinfo

		if args['time_interval'] == '4 hours':
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		elif args['time_interval'] == '1 day':
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(minutes = 30)
		else: # 2 days
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(hours = 1)

		#logging.debug("previous_time: " + str(previous_time))
		#logging.debug("end_time: " + str(end_time))

		def sort_by_bw(row1, row2):
			if cmp(row1[TALKER], -1) == 0 or row1[TALKER] == '0.0.0.0':
				return 1
			elif cmp(row2[TALKER], -1) == 0 or row2[TALKER] == '0.0.0.0':
				return -1 
			elif float(row1[BW]) < float(row2[BW]):
				return 1
			elif float(row1[BW]) == float(row2[BW]):
				return 0
			else:
				return -1
	   
		def datesAreEqual(date1, date2):
		        #logging.debug("date1: " + str(date1))
		        #logging.debug("date2: " + str(date2))
			if date1.year == date2.year:
				if date1.month == date2.month:
					if date1.day == date2.day:
						if date1.hour == date2.hour:
							if date1.minute == date2.minute:
								return True
			return False

		resultList = []
		dataseries = dict()
		datainfo = dict()
		xcoord = 0

		if args['time_interval'] == '4 hours':
		    time_delta = timedelta(minutes = 5)
		elif args['time_interval'] == '1 day':
		    time_delta = timedelta(minutes = 30)
		else: # 2 days
		    time_delta = timedelta(hours = 1)

		if len(results) > 0:
			for i in range(args['num_talkers'] + 1):
				dataseries[i] = []

		for i in range(len(results)):
			#logging.debug("result time: " + str(results[i][INTERVAL]))
			#logging.debug("previous time: " + str(previous_time))
			if(datesAreEqual(results[i][INTERVAL],previous_time)):
				resultList.append(results[i])
				if i == (len(results) -1):
					resultList.sort(sort_by_bw)
					for j in range(len(resultList)):
						stackedBW = 0
						for k in range(j,len(resultList),1):
							stackedBW += float(resultList[k][BW])
						talker = str(resultList[j][TALKER])
						dataseries[j].append([xcoord,stackedBW,talker])
						bw = resultList[j][BW]
						if talker in datainfo:
							datainfo[talker] += bw
						else:
							datainfo[talker] = bw

					for j in range((len(resultList)),args['num_talkers'] + 1):
						dataseries[j].append([xcoord,0,'-2'])
					xcoord += 1
					previous_time += time_delta
 
					while(datesAreEqual(previous_time, end_time) == False):
						for key in dataseries.keys():
							dataseries[key].append([xcoord,0,'-2'])
						previous_time += time_delta
						xcoord += 1

			elif len(resultList) == 0:
				resultList.append(results[i])
				while (datesAreEqual(results[i][INTERVAL],previous_time) == False):
					for key in dataseries.keys():
						dataseries[key].append([xcoord,0,'-2'])

					previous_time += time_delta
					xcoord += 1
			else:
				resultList.sort(sort_by_bw)
				for j in range(len(resultList)):
					stackedBW = 0
					for k in range(j,len(resultList),1):
						stackedBW += float(resultList[k][BW])
					talker = str(resultList[j][TALKER])
					dataseries[j].append([xcoord,stackedBW,talker])
					bw = resultList[j][BW]
					if talker in datainfo:
						datainfo[talker] += bw
					else:
						datainfo[talker] = bw

				for j in range((len(resultList)),args['num_talkers'] + 1):
					dataseries[j].append([xcoord,0,'-2'])

				resultList = []
				resultList.append(results[i])
				previous_time += time_delta
				xcoord += 1

				while (datesAreEqual(results[i][INTERVAL],previous_time) == False):
				   for key in dataseries.keys():
					   dataseries[key].append([xcoord,0,'-2'])

				   previous_time += time_delta
				   xcoord += 1
		
		#logging.debug("dataseries: " + str(dataseries))
		#logging.debug("datainfo: " + str(datainfo))

		return dict(dataseries=dataseries,datainfo=datainfo)

	def do_bw_by_interval(self,args):

		# order is important,
		# it will be the order which they
		# they are specified in the stored procedure
		spParamsList = []
		spParamsList.append('internal_net')
		spParamsList.append('start_time')
		spParamsList.append('end_time')
		spParamsList.append('time_interval')
		spParamsList.append('direction')

		spParams = dict([(param, 'null') for param in spParamsList])

		# replace parameters specified by args
		for key in args.keys():
			if (args[key] != None):
				spParams[key] = "'" +  str(args[key]) + "'"

		spString = 'select * from bw_by_interval('

		for i in range(len(spParamsList)):
			if i > 0:
				spString += ','
			spString += '$' + spParamsList[i]

		spString += ')'

		sql = Template(spString)
		sql = sql.substitute(spParams)

		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
		except:
			logging.error("Error executing the stored procedure bw_by_interval")
			self.conn.rollback()
			return None

		results = cur.fetchall()

		if results[0][1] == None:
			self.conn.commit()
			return None

		try:
			cur.execute("fetch all from \"" + results[0][1] + "\"") 
		except:
			logging.error("Error fetching data from the results cursor in the stored procedure bw_by_interval.")
			self.conn.rollback()
			return None

		results = cur.fetchall()
		self.conn.commit()

		# figure out what the first interval is supposed to be 
		# TODO: convert to a function that handles multiple intervals
		start_time = args['start_time']
		year = start_time.year
		month = start_time.month
		day = start_time.day
		hour = start_time.hour
		minute = ((start_time.minute / 5) * 5 )
		tzinfo = start_time.tzinfo

		if args['time_interval'] == 'hour':
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		elif args['time_interval'] == 'day':
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		else: # week
		    previous_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(hours = 1)

		# figure out what the last interval is supposed to be 
		end_time = args['end_time']
		year = end_time.year
		month = end_time.month
		day = end_time.day
		hour = end_time.hour
		minute = ((start_time.minute / 5) * 5 )
		tzinfo = end_time.tzinfo

		if args['time_interval'] == 'hour':
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		elif args['time_interval'] == 'day':
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=minute,tzinfo=tzinfo) + timedelta(minutes = 5)
		else: # week
		    end_time = datetime(year=year,month=month,day=day,hour=hour,minute=0,tzinfo=tzinfo) + timedelta(hours = 1)

		#logging.debug("previous_time: " + str(previous_time))
		#logging.debug("end_time: " + str(end_time))
	   
		def datesAreEqual(date1, date2):
		        #logging.debug("date1: " + str(date1))
			#logging.debug("date2: " + str(date2))
			if date1.year == date2.year:
				if date1.month == date2.month:
					if date1.day == date2.day:
						if date1.hour == date2.hour:
						    if date1.minute == date2.minute:
							return True
			return False

		INTERVAL = 0
		BW = 1
		dataseries = []
		xcoord = 0

		if args['time_interval'] == 'hour':
		    time_delta = timedelta(minutes = 5)
		elif args['time_interval'] == 'day':
		    time_delta = timedelta(minutes = 5)
		else: # week
		    time_delta = timedelta(hours = 1)

		for res in results:
			while (datesAreEqual(res[INTERVAL],previous_time) == False):
			    dataseries.append([xcoord,0])
			    previous_time += time_delta
			    xcoord += 1

			bw = int(res[BW])
		        dataseries.append([xcoord,bw])
			previous_time += time_delta
		        xcoord += 1

		while (datesAreEqual(end_time,previous_time) == False):
		    dataseries.append([xcoord,0])
		    previous_time += time_delta
		    xcoord += 1
		
		return dataseries

	def do_add_internal_net(self, args):
		sql = 'select * from add_internal_net(' + args['mgmt_network'] + ')'
		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
			self.conn.commit()
		except:
			logging.error("Error executing the stored procedure add_internal_net")
			self.conn.rollback()
			return None
	 
                cur.close()	
		return

	def do_remove_internal_net(self, args):
		sql = 'select * from remove_internal_net(' + args['mgmt_network'] + ')'
		cur = self.conn.cursor()

		try:
		        logging.debug(sql)
			cur.execute(sql)
			self.conn.commit()
		except:
			logging.error("Error executing the stored procedure remove_internal_net")
			self.conn.rollback()
			return None
		
                cur.close()	
		return
		
	def dispatch(self, command, args):
		method_name = 'do_' + command
		if(hasattr(self,method_name)):
			method = getattr(self, method_name)
			return method(args)
		else:
			self.error()

	def error(self):
		pass
		#logging.error('Error')

